CodeForces 144C - Anagram Search(哈希算法)

A string t is called an anagram of the string s, if it is possible to rearrange letters in t so that it is identical to the string s. For example, the string “aab” is an anagram of the string “aba” and the string “aaa” is not.

The string t is called a substring of the string s if it can be read starting from some position in the string s. For example, the string “aba” has six substrings: “a”, “b”, “a”, “ab”, “ba”, “aba”.

You are given a string s, consisting of lowercase Latin letters and characters “?”. You are also given a string p, consisting of lowercase Latin letters only. Let’s assume that a string is good if you can obtain an anagram of the string p from it, replacing the “?” characters by Latin letters. Each “?” can be replaced by exactly one character of the Latin alphabet. For example, if the string p = «aba», then the string “a??” is good, and the string «?bc» is not.

Your task is to find the number of good substrings of the string s (identical substrings must be counted in the answer several times).

Input
The first line is non-empty string s, consisting of no more than 105 lowercase Latin letters and characters “?”. The second line is non-empty string p, consisting of no more than 105 lowercase Latin letters. Please note that the length of the string p can exceed the length of the string s.

Output
Print the single number representing the number of good substrings of string s.

Two substrings are considered different in their positions of occurrence are different. Thus, if some string occurs several times, then it should be counted the same number of times.

Examples
Input
bb??x???
aab
Output
2
Input
ab?c
acb
Output
2
Note
Consider the first sample test. Here the string s has two good substrings: “b??” (after we replace the question marks we get “baa”), “???” (after we replace the question marks we get “baa”).

Let’s consider the second sample test. Here the string s has two good substrings: “ab?” (“?” can be replaced by “c”), “b?c” (“?” can be replaced by “a”).

题目链接
参考题解

题目要求找第二个字符串能形成第一个字符串的连续子串的个数。
这个题目看大佬好像用了什么哈希算法,记录第二个字符串中每一个小写字母出现的次数,然后再对第一个字符串进行遍历,到达第二个字符串的长度之后就判断,是不是每一个第一个的连续子串中出现的小写字母次数都小于第二个,因为有问号的存在,所以小于的话是完全可以的,但是如果大于一定是无法匹配的,因为第二个字符串无法提供那么多该字母。具体还是看代码:
AC代码:

#include <cstdio>
#include <cstring>
using namespace std;
const int maxn = 1e5 + 5;
char str_1[maxn], str_2[maxn];  //记录两个字符串
int letter_1[26], letter_2[26]; //记录两个字符串中每一个字符出现的次数

int main()
{
    int ans, len_1, len_2;
    bool flag;
    while(~scanf("%s%s", str_1, str_2))
    {
        //初始化letter为0
        memset(letter_1, 0, sizeof(letter_1));
        memset(letter_2, 0, sizeof(letter_2));
        len_1 = strlen(str_1), len_2 = strlen(str_2);
        ans = 0;
        //先将第二个字符串中出现字符的数量统计下来
        for(int i = 0; i < len_2; i++)  letter_2[str_2[i] - 'a']++;
        for(int i = 0; i < len_1; i++)
        {
            flag = true;
            letter_1[str_1[i] - 'a']++;
            if(i < len_2 - 1)   continue ;
            for(int j = 0; j < 26; j++)
                if(letter_1[j] > letter_2[j])   //如果有一个字符比第二个多的话,那么一定不匹配
                {
                    flag = false;
                    break ;
                }
            if(flag)    ans++;
            letter_1[str_1[i - (len_2 - 1)] - 'a']--;   //头上的字符数量减去一
        }
        printf("%d\n", ans);
    }
    return 0;
}

    原文作者:哈希算法
    原文地址: https://blog.csdn.net/weixin_40788897/article/details/83054134
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞